--- old/usr/src/cmd/mdb/common/modules/ip/ip.c	2012-08-18 10:37:02.205360760 +0000
+++ new/usr/src/cmd/mdb/common/modules/ip/ip.c	2012-08-18 10:37:02.263975689 +0000
@@ -341,7 +341,7 @@
 
 /*
  * Generic network stack walker initialization function.  It is used by all
- * other netwrok stack walkers.
+ * other network stack walkers.
  */
 int
 ns_walk_init(mdb_walk_state_t *wsp)
@@ -374,6 +374,15 @@
 }
 
 /*
+ * DCCP network stack walker stepping function.
+ */
+int
+dccp_stacks_walk_step(mdb_walk_state_t *wsp)
+{
+	return (ns_walk_step(wsp, NS_DCCP));
+}
+
+/*
  * IP network stack walker stepping function.
  */
 int
@@ -1953,6 +1962,8 @@
 		nce_walk_init, nce_walk_step, NULL },
 	{ "dce", "walk active dce_t structures",
 		dce_walk_init, dce_walk_step, NULL },
+	{ "dccp_stacks", "walk all the dccp_stack_t",
+		ns_walk_init, dccp_stacks_walk_step, NULL },
 	{ "ip_stacks", "walk all the ip_stack_t",
 		ns_walk_init, ip_stacks_walk_step, NULL },
 	{ "tcp_stacks", "walk all the tcp_stack_t",
--- old/usr/src/lib/libdtrace/Makefile.com	2012-08-18 10:37:02.745786664 +0000
+++ new/usr/src/lib/libdtrace/Makefile.com	2012-08-18 10:37:02.779340038 +0000
@@ -73,6 +73,7 @@
 DRTIOBJ = $(DRTISRC:%.c=%.o)
 
 DLIBSRCS += \
+	dccp.d \
 	errno.d \
 	fc.d \
 	io.d \
@@ -109,6 +110,7 @@
 CLEANFILES += ../common/sysevent.sed ../common/sysevent.d
 CLEANFILES += ../common/tcp.sed ../common/tcp.d
 CLEANFILES += ../common/udp.sed ../common/udp.d
+CLEANFILES += ../common/dccp.sed ../common/dccp.d
 
 CLOBBERFILES += drti.o
 
@@ -193,6 +195,9 @@
 ../common/udp.d: ../common/udp.sed ../common/udp.d.in
 	sed -f ../common/udp.sed < ../common/udp.d.in > $@
 
+../common/dccp.d: ../common/dccp.sed ../common/dccp.d.in
+	sed -f ../common/dccp.sed < ../common/dccp.d.in > $@
+
 pics/%.o: ../$(MACH)/%.c
 	$(COMPILE.c) -o $@ $<
 	$(POST_PROCESS_O)
--- /dev/null	2012-08-18 10:37:03.000000000 +0000
+++ new/usr/src/lib/libdtrace/common/dccp.d.in	2012-08-18 10:37:03.150470353 +0000
@@ -0,0 +1,181 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+#pragma D depends_on module unix
+#pragma D depends_on provider dccp
+
+inline int32_t DCCP_STATE_CLOSED = @DCCPS_CLOSED@;
+#pragma D binding "1.10" DCCP_STATE_CLOSED
+inline int32_t DCCP_STATE_BOUND = @DCCPS_BOUND@;
+#pragma D binding "1.10" DCCP_STATE_BOUND
+inline int32_t DCCP_STATE_REQUEST = @DCCPS_REQUEST@;
+#pragma D binding "1.10" DCCP_STATE_REQUEST
+inline int32_t DCCP_STATE_LISTEN = @DCCPS_LISTEN@;
+#pragma D binding "1.10" DCCP_STATE_LISTEN
+inline int32_t DCCP_STATE_PARTOPEN = @DCCPS_PARTOPEN@;
+#pragma D binding "1.10" DCCP_STATE_PARTOPEN
+inline int32_t DCCP_STATE_RESPOND = @DCCPS_RESPOND@;
+#pragma D binding "1.10" DCCP_STATE_RESPOND
+inline int32_t DCCP_STATE_OPEN = @DCCPS_OPEN@;
+#pragma D binding "1.10" DCCP_STATE_OPEN
+inline int32_t DCCP_STATE_CLOSING = @DCCPS_CLOSING@;
+#pragma D binding "1.10" DCCP_STATE_CLOSING
+inline int32_t DCCP_STATE_CLOSEREQ = @DCCPS_CLOSEREQ@;
+#pragma D binding "1.10" DCCP_STATE_CLOSEREQ
+inline int32_t DCCP_STATE_TIMEWAIT = @DCCPS_TIMEWAIT@;
+#pragma D binding "1.10" DCCP_STATE_TIMEWAIT
+
+/*
+ * Convert a DCCP state value to a string.
+ */
+inline string dccp_state_string[int32_t state] =
+	state == DCCP_STATE_CLOSED ? "state-closed" :
+	state == DCCP_STATE_BOUND ? "state-bound" :
+	state == DCCP_STATE_REQUEST ? "state-request" :
+	state == DCCP_STATE_LISTEN ? "state-listen" :
+	state == DCCP_STATE_PARTOPEN ? "state-partopen" :
+	state == DCCP_STATE_RESPOND ? "state-respond" :
+	state == DCCP_STATE_OPEN ? "state-open" :
+	state == DCCP_STATE_CLOSING ? "state-closing" :
+	state == DCCP_STATE_CLOSEREQ ? "state-closereq" :
+	state == DCCP_STATE_TIMEWAIT ? "state-timewait" :
+	"<unknown>";
+#pragma D binding "1.10" dccp_state_string
+
+/*
+ * dccpinfo is the DCCP header fields.
+ */
+typedef struct dccpinfo {
+	uint16_t dccp_sport;		/* source port */
+	uint16_t dccp_dport;		/* destination port */
+	uint32_t dccp_seq;		/* sequence number */
+	uint8_t dccp_offset;		/* data offset, in bytes */
+	uint16_t dccp_checksum;		/* checksum */
+	dccph_t *dccp_hdr;		/* raw DCCP header */
+} dccpinfo_t;
+
+/*
+ * dccpsinfo contains stable DCCP details from dccp_t.
+ */
+typedef struct dccpsinfo {
+	uintptr_t dccps_addr;
+	int dccps_local;		/* Is delivered locally, boolean */
+	int dccps_active;		/* Active open (from here), boolean */
+	uint16_t dccps_lport;		/* Local port */
+	uint16_t dccps_rport;		/* Remote port */
+	string dccps_laddr;		/* Local address, as a string */
+	string dccps_raddr;		/* Remote address, as a string */
+	int32_t dccps_state;		/* DCCP state */
+	uint32_t dccps_iss;		/* Initial sequence # sent */
+} dccpsinfo_t;
+
+/*
+ * dccplsinfo provides the old dccp state for state changes.
+ */
+typedef struct dccplsinfo {
+	int32_t dccps_state;		/* Previous DCCP state */
+} dccplsinfo_t;
+
+/*
+ * __dtrace_tcp_tcph_t is used by the tcpinfo_t * translator to take either
+ * the non-NULL tcph_t * passed in or, if it is NULL, uses arg3 (tcp_t *)
+ * from the tcp:::send and tcp:::recieve probes and translates the tcp_t *
+ * into the tcpinfo_t.  When no headers are available - as is the case for
+ * TCP fusion tcp:::send and tcp:::receive - this allows us to present the
+ * consumer with header data based on tcp_t * content and hide TCP fusion
+ * implementation details.
+ */
+typedef dccph_t * __dtrace_dccp_dccph_t;
+
+#pragma D binding "1.10" translator
+translator dccpinfo_t < dccph_t *T > {
+	dccp_sport = ntohs(*(uint16_t *)T->dh_lport);
+	dccp_dport = ntohs(*(uint16_t *)T->dh_fport);
+	dccp_seq = ntohl(*(uint32_t *)T->dh_seq); /* XXX */
+	dccp_offset = (*(uint8_t *)T->dh_offset & 0xf0) >> 2;
+	dccp_checksum = ntohs(*(uint16_t *)T->dh_sum);
+	dccp_hdr = T;
+};
+
+#pragma D binding "1.10" translator
+translator dccpinfo_t < __dtrace_dccp_dccph_t *T > {
+	dccp_sport =
+	    T != NULL ? ntohs(*(uint16_t *)((dccph_t *)T)->dh_lport) :
+	    arg3 != NULL && probename == "send" ?
+	    ntohs(((dccp_t *)arg3)->dccp_connp->u_port.connu_ports.connu_lport) :
+	    arg3 != NULL && probename == "receive" ?
+	    ntohs(((dccp_t *)arg3)->dccp_connp->u_port.connu_ports.connu_fport) :
+	    0;
+	dccp_dport =
+	    T != NULL ? ntohs(*(uint16_t *)((dccph_t *)T)->dh_fport) :
+	    arg3 != NULL && probename == "send" ?
+	    ntohs(((dccp_t *)arg3)->dccp_connp->u_port.connu_ports.connu_fport) :
+	    arg3 != NULL && probename == "receive" ?
+	    ntohs(((dccp_t *)arg3)->dccp_connp->u_port.connu_ports.connu_lport) :
+	    0;
+	dccp_seq =
+	    T != NULL ? ntohl(*(uint32_t *)((dccph_t *)T)->dh_seq) :
+	    0;
+	dccp_offset = T != NULL ?
+	    (*(uint8_t *)((dccph_t *)T)->dh_offset & 0xf0) >> 2 :
+	    @DCCP_MIN_HEADER_LENGTH@;
+	dccp_checksum = T != NULL ? ntohs(*(uint16_t *)((dccph_t *)T)->dh_sum) :
+	    0;
+	dccp_hdr = NULL;
+};
+
+#pragma D binding "1.10" translator
+translator dccpsinfo_t < dccp_t *T > {
+	dccps_addr = (uintptr_t)T;
+	/*
+	 * The following two members should just use tcp_t->tcp_loopback
+	 * and tcp_t->tcp_active_open, however these are bit fields and
+	 * can't be used until CR 6876830 is fixed.  Meanwhile we source
+	 * them a different way.
+	 */
+	dccps_local = T ? T->dccp_ipha ?
+	    T->dccp_ipha->ipha_src == T->dccp_ipha->ipha_dst : 1 : 0;
+	dccps_active = T ? !T->dccp_saved_listener : 0;
+	dccps_lport = T ?
+	    ntohs(T->dccp_connp->u_port.connu_ports.connu_lport) : 0;
+	dccps_rport = T ?
+	    ntohs(T->dccp_connp->u_port.connu_ports.connu_fport) : 0;
+	dccps_laddr = T ?
+	    inet_ntoa6(&T->dccp_connp->connua_v6addr.connua_laddr) : "<unknown>";
+	dccps_raddr = T ?
+	    inet_ntoa6(&T->dccp_connp->connua_v6addr.connua_faddr) : "<unknown>";
+	dccps_state = T ? T->dccp_state : DCCP_STATE_CLOSED;
+	dccps_iss = T ? T->dccp_iss : 0;
+};
+
+/*
+ * Note: although we specify that the old state argument used as the
+ * input to the tcplsinfo_t translator is an int32_t, it reaches us as an
+ * int64_t (since it is a probe argument) so explicitly cast it back to
+ * interpret the negatively-valued states correctly.
+ */
+#pragma D binding "1.10" translator
+translator dccplsinfo_t < int64_t I > {
+	dccps_state = (int32_t) I;
+};
--- /dev/null	2012-08-18 10:37:03.000000000 +0000
+++ new/usr/src/lib/libdtrace/common/dccp.sed.in	2012-08-18 10:37:03.330628152 +0000
@@ -0,0 +1,42 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+#include <inet/dccp.h>
+#include <sys/netstack.h>
+
+#define	SED_REPLACE(x)	s/#x/x/g
+
+
+SED_REPLACE(DCCPS_CLOSED)
+SED_REPLACE(DCCPS_BOUND)
+SED_REPLACE(DCCPS_REQUEST)
+SED_REPLACE(DCCPS_LISTEN)
+SED_REPLACE(DCCPS_PARTOPEN)
+SED_REPLACE(DCCPS_RESPOND)
+SED_REPLACE(DCCPS_OPEN)
+SED_REPLACE(DCCPS_CLOSING)
+SED_REPLACE(DCCPS_CLOSEREQ)
+SED_REPLACE(DCCPS_TIMEWAIT)
+
+SED_REPLACE(DCCP_MIN_HEADER_LENGTH)
--- old/usr/src/lib/libdtrace/common/dt_open.c	2012-08-18 10:37:03.472135181 +0000
+++ new/usr/src/lib/libdtrace/common/dt_open.c	2012-08-18 10:37:03.506251130 +0000
@@ -110,8 +110,9 @@
 #define	DT_VERS_1_8	DT_VERSION_NUMBER(1, 8, 0)
 #define	DT_VERS_1_8_1	DT_VERSION_NUMBER(1, 8, 1)
 #define	DT_VERS_1_9	DT_VERSION_NUMBER(1, 9, 0)
-#define	DT_VERS_LATEST	DT_VERS_1_9
-#define	DT_VERS_STRING	"Sun D 1.9"
+#define	DT_VERS_1_10	DT_VERSION_NUMBER(1, 10, 0)
+#define	DT_VERS_LATEST	DT_VERS_1_10
+#define	DT_VERS_STRING	"Sun D 1.10"
 
 const dt_version_t _dtrace_versions[] = {
 	DT_VERS_1_0,	/* D API 1.0.0 (PSARC 2001/466) Solaris 10 FCS */
@@ -132,6 +133,7 @@
 	DT_VERS_1_8,	/* D API 1.8 */
 	DT_VERS_1_8_1,	/* D API 1.8.1 */
 	DT_VERS_1_9,	/* D API 1.9 */
+	DT_VERS_1_10,	/* D API 1.10 */
 	0
 };
 
--- old/usr/src/lib/libdtrace/common/ip.d.in	2012-08-18 10:37:03.936540231 +0000
+++ new/usr/src/lib/libdtrace/common/ip.d.in	2012-08-18 10:37:03.976861008 +0000
@@ -86,6 +86,8 @@
 inline int IPPROTO_RAW = @IPPROTO_RAW@;
 #pragma D binding "1.5" IPPROTO_MAX
 inline int IPPROTO_MAX = @IPPROTO_MAX@;
+#pragma D binding "1.10" IPPROTO_DCCP
+inline int IPPROTO_DCCP = @IPPROTO_DCCP@;
 
 /*
  * pktinfo is where packet ID info can be made available for deeper
--- old/usr/src/lib/libdtrace/common/ip.sed.in	2012-08-18 10:37:04.406902794 +0000
+++ new/usr/src/lib/libdtrace/common/ip.sed.in	2012-08-18 10:37:04.419268282 +0000
@@ -71,6 +71,7 @@
 SED_REPLACE(IPPROTO_PIM)
 SED_REPLACE(IPPROTO_SCTP)
 SED_REPLACE(IPPROTO_RAW)
+SED_REPLACE(IPPROTO_DCCP)
 SED_REPLACE(IPPROTO_MAX)
 
 SED_REPLACE(TCP_MIN_HEADER_LENGTH)
--- old/usr/src/lib/libipadm/common/ipadm_prop.c	2012-08-18 10:37:04.826353628 +0000
+++ new/usr/src/lib/libipadm/common/ipadm_prop.c	2012-08-18 10:37:04.886186356 +0000
@@ -26,7 +26,7 @@
  * This file contains routines that are used to modify/retrieve protocol or
  * interface property values. It also holds all the supported properties for
  * both IP interface and protocols in `ipadm_prop_desc_t'. Following protocols
- * are supported: IP, IPv4, IPv6, TCP, SCTP, UDP and ICMP.
+ * are supported: IP, IPv4, IPv6, TCP, SCTP, UDP, ICMP and DCCP.
  *
  * This file also contains walkers, which walks through the property table and
  * calls the callback function, of the form `ipadm_prop_wfunc_t' , for every
@@ -82,7 +82,7 @@
 /* array of protocols we support */
 static int protocols[] = { MOD_PROTO_IP, MOD_PROTO_RAWIP,
 			    MOD_PROTO_TCP, MOD_PROTO_UDP,
-			    MOD_PROTO_SCTP };
+			    MOD_PROTO_SCTP, MOD_PROTO_DCCP };
 
 /*
  * Supported IP protocol properties.
@@ -239,6 +239,30 @@
 	{ NULL, 0, 0, 0, NULL, NULL, NULL }
 };
 
+/* Supported DCCP protocol properties */
+static ipadm_prop_desc_t ipadm_dccp_prop_table[] = {
+	{ "extra_priv_ports", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP,
+	    IPADMPROP_MULVAL, i_ipadm_set_eprivport, i_ipadm_get_prop,
+	    i_ipadm_get_prop },
+
+	{ "largest_anon_port", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP, 0,
+	    i_ipadm_set_prop, i_ipadm_get_prop, i_ipadm_get_prop },
+
+	{ "recv_maxbuf", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP, 0,
+	    i_ipadm_set_prop, i_ipadm_get_prop, i_ipadm_get_prop },
+
+	{ "send_maxbuf", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP, 0,
+	    i_ipadm_set_prop, i_ipadm_get_prop, i_ipadm_get_prop },
+
+	{ "smallest_anon_port", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP, 0,
+	    i_ipadm_set_prop, i_ipadm_get_prop, i_ipadm_get_prop },
+
+	{ "smallest_nonpriv_port", IPADMPROP_CLASS_MODULE, MOD_PROTO_DCCP, 0,
+	    i_ipadm_set_prop, i_ipadm_get_prop, i_ipadm_get_prop },
+
+	{ NULL, 0, 0, 0, NULL, NULL, NULL }
+};
+
 /*
  * A dummy private property structure, used while handling private
  * protocol properties (properties not yet supported by libipadm).
@@ -266,6 +290,8 @@
 		return (ipadm_udp_prop_table);
 	case MOD_PROTO_SCTP:
 		return (ipadm_sctp_prop_table);
+	case MOD_PROTO_DCCP:
+		return (ipadm_dccp_prop_table);
 	}
 
 	return (NULL);
@@ -320,6 +346,8 @@
 		return ("udp");
 	case MOD_PROTO_SCTP:
 		return ("sctp");
+	case MOD_PROTO_DCCP:
+		return ("dccp");
 	}
 
 	return (NULL);
@@ -346,6 +374,8 @@
 		return (MOD_PROTO_SCTP);
 	else if (strcmp(protostr, "arp") == 0)
 		return (MOD_PROTO_IP);
+	else if (strcmp(protostr, "dccp") == 0)
+		return (MOD_PROTO_DCCP);
 
 	return (MOD_PROTO_NONE);
 }
--- old/usr/src/pkg/manifests/developer-dtrace.mf	2012-08-18 10:37:05.360309075 +0000
+++ new/usr/src/pkg/manifests/developer-dtrace.mf	2012-08-18 10:37:05.422012677 +0000
@@ -179,6 +179,7 @@
 file path=usr/lib/$(ARCH64)/llib-ldtrace.ln
 file path=usr/lib/devfsadm/linkmod/SUNW_dtrace_link.so group=sys
 file path=usr/lib/dtrace/64/drti.o
+file path=usr/lib/dtrace/dccp.d
 file path=usr/lib/dtrace/drti.o
 file path=usr/lib/dtrace/errno.d
 file path=usr/lib/dtrace/fc.d
--- old/usr/src/pkg/manifests/system-header.mf	2012-08-18 10:37:05.800568505 +0000
+++ new/usr/src/pkg/manifests/system-header.mf	2012-08-18 10:37:05.848117403 +0000
@@ -400,6 +400,10 @@
 file path=usr/include/ifaddrs.h
 file path=usr/include/inet/arp.h
 file path=usr/include/inet/common.h
+file path=usr/include/inet/dccp.h
+file path=usr/include/inet/dccp_ip.h
+file path=usr/include/inet/dccp_stack.h
+file path=usr/include/inet/dccp_stats.h
 file path=usr/include/inet/ip.h
 file path=usr/include/inet/ip6.h
 file path=usr/include/inet/ip6_asp.h
@@ -556,6 +560,7 @@
 file path=usr/include/netdb.h
 file path=usr/include/netdir.h
 file path=usr/include/netinet/arp.h
+file path=usr/include/netinet/dccp.h
 file path=usr/include/netinet/dhcp.h
 file path=usr/include/netinet/dhcp6.h
 file path=usr/include/netinet/icmp6.h
--- old/usr/src/pkg/manifests/system-kernel.mf	2012-08-18 10:37:06.252023962 +0000
+++ new/usr/src/pkg/manifests/system-kernel.mf	2012-08-18 10:37:06.261816404 +0000
@@ -126,6 +126,8 @@
 driver name=crypto perms="crypto 0666 root sys"
 driver name=cryptoadm perms="cryptoadm 0644 root sys"
 $(sparc_ONLY)driver name=dad alias=ide-disk perms="* 0640 root sys"
+driver name=dccp perms="dccp 0666 root sys"
+driver name=dccp6 perms="dccp6 0666 root sys"
 driver name=devinfo perms="devinfo 0640 root sys" \
     perms="devinfo,ro 0444 root sys"
 driver name=dld perms="* 0666 root sys"
@@ -341,6 +343,8 @@
 file path=kernel/drv/$(ARCH64)/crypto group=sys
 file path=kernel/drv/$(ARCH64)/cryptoadm group=sys
 $(sparc_ONLY)file path=kernel/drv/$(ARCH64)/dad group=sys
+file path=kernel/drv/$(ARCH64)/dccp group=sys
+file path=kernel/drv/$(ARCH64)/dccp6 group=sys
 file path=kernel/drv/$(ARCH64)/devinfo group=sys
 file path=kernel/drv/$(ARCH64)/dld group=sys
 file path=kernel/drv/$(ARCH64)/dlpistub group=sys
@@ -439,6 +443,10 @@
 $(i386_ONLY)file path=kernel/drv/cryptoadm group=sys
 file path=kernel/drv/cryptoadm.conf group=sys
 $(sparc_ONLY)file path=kernel/drv/dad.conf group=sys
+$(i386_ONLY)file path=kernel/drv/dccp group=sys
+file path=kernel/drv/dccp.conf group=sys
+$(i386_ONLY)file path=kernel/drv/dccp6 group=sys
+file path=kernel/drv/dccp6.conf group=sys
 $(i386_ONLY)file path=kernel/drv/devinfo group=sys
 file path=kernel/drv/devinfo.conf group=sys
 $(i386_ONLY)file path=kernel/drv/dld group=sys
@@ -826,6 +834,8 @@
 $(i386_ONLY)hardlink path=kernel/misc/md5 target=../../kernel/crypto/md5
 $(i386_ONLY)hardlink path=kernel/misc/sha1 target=../../kernel/crypto/sha1
 $(i386_ONLY)hardlink path=kernel/misc/sha2 target=../../kernel/crypto/sha2
+hardlink path=kernel/socketmod/$(ARCH64)/dccp \
+    target=../../../kernel/drv/$(ARCH64)/dccp
 hardlink path=kernel/socketmod/$(ARCH64)/icmp \
     target=../../../kernel/drv/$(ARCH64)/icmp
 hardlink path=kernel/socketmod/$(ARCH64)/rts \
@@ -834,12 +844,15 @@
     target=../../../kernel/drv/$(ARCH64)/tcp
 hardlink path=kernel/socketmod/$(ARCH64)/udp \
     target=../../../kernel/drv/$(ARCH64)/udp
+$(i386_ONLY)hardlink path=kernel/socketmod/dccp target=../../kernel/drv/dccp
 $(i386_ONLY)hardlink path=kernel/socketmod/icmp target=../../kernel/drv/icmp
 $(i386_ONLY)hardlink path=kernel/socketmod/rts target=../../kernel/drv/rts
 $(i386_ONLY)hardlink path=kernel/socketmod/tcp target=../../kernel/drv/tcp
 $(i386_ONLY)hardlink path=kernel/socketmod/udp target=../../kernel/drv/udp
 hardlink path=kernel/strmod/$(ARCH64)/arp \
     target=../../../kernel/drv/$(ARCH64)/arp
+hardlink path=kernel/strmod/$(ARCH64)/dccp \
+    target=../../../kernel/drv/$(ARCH64)/dccp
 hardlink path=kernel/strmod/$(ARCH64)/icmp \
     target=../../../kernel/drv/$(ARCH64)/icmp
 hardlink path=kernel/strmod/$(ARCH64)/ip \
@@ -855,6 +868,7 @@
 hardlink path=kernel/strmod/$(ARCH64)/udp \
     target=../../../kernel/drv/$(ARCH64)/udp
 $(i386_ONLY)hardlink path=kernel/strmod/arp target=../../kernel/drv/arp
+$(i386_ONLY)hardlink path=kernel/strmod/dccp target=../../kernel/drv/dccp
 $(i386_ONLY)hardlink path=kernel/strmod/icmp target=../../kernel/drv/icmp
 $(i386_ONLY)hardlink path=kernel/strmod/ip target=../../kernel/drv/ip
 $(i386_ONLY)hardlink path=kernel/strmod/ipsecah \
--- old/usr/src/uts/common/Makefile.files	2012-08-18 10:37:06.701807517 +0000
+++ new/usr/src/uts/common/Makefile.files	2012-08-18 10:37:06.749654936 +0000
@@ -542,6 +542,9 @@
 		sctp_addr.o tn_ipopt.o tnet.o ip_netinfo.o \
 		sctp_misc.o
 IP_ILB_OBJS =	ilb.o ilb_nat.o ilb_conn.o ilb_alg_hash.o ilb_alg_rr.o
+IP_DCCP_OBJS =	dccp.o dccp_bind.o dccp_features.o dccp_input.o dccp_misc.o \
+		dccp_opt_data.o dccp_options.o dccp_output.o dccp_stats.o \
+		dccp_socket.o dccp_timers.o dccp_tpi.o dccp_tunables.o
 
 IP_OBJS +=	igmp.o ipmp.o ip.o ip6.o ip6_asp.o ip6_if.o ip6_ire.o \
 		ip6_rts.o ip_if.o ip_ire.o ip_listutils.o ip_mroute.o \
@@ -557,7 +560,8 @@
 		$(IP_TCP_OBJS) \
 		$(IP_UDP_OBJS) \
 		$(IP_SCTP_OBJS) \
-		$(IP_ILB_OBJS)
+		$(IP_ILB_OBJS) \
+		$(IP_DCCP_OBJS)
 
 IP6_OBJS +=	ip6ddi.o
 
@@ -616,6 +620,10 @@
 
 UDP6_OBJS +=	udp6ddi.o
 
+DCCP_OBJS +=	dccpddi.o
+
+DCCP6_OBJS +=	dccp6ddi.o
+
 SY_OBJS +=	gentty.o
 
 TCO_OBJS +=	ticots.o
--- old/usr/src/uts/common/Makefile.rules	2012-08-18 10:37:07.124748775 +0000
+++ new/usr/src/uts/common/Makefile.rules	2012-08-18 10:37:07.158380336 +0000
@@ -476,6 +476,10 @@
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
 
+$(OBJS_DIR)/%.o:		$(UTSBASE)/common/inet/dccp/%.c
+	$(COMPILE.c) -o $@ $<
+	$(CTFCONVERT_O)
+
 $(OBJS_DIR)/%.o:		$(UTSBASE)/common/inet/ip/%.c
 	$(COMPILE.c) -o $@ $<
 	$(CTFCONVERT_O)
@@ -1877,6 +1881,9 @@
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/inet/arp/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
+$(LINTS_DIR)/%.ln:		$(UTSBASE)/common/inet/dccp/%.c
+	@($(LHEAD) $(LINT.c) $< $(LTAIL))
+
 $(LINTS_DIR)/%.ln:		$(UTSBASE)/common/inet/ip/%.c
 	@($(LHEAD) $(LINT.c) $< $(LTAIL))
 
--- old/usr/src/uts/common/dtrace/sdt_subr.c	2012-08-18 10:37:07.648695804 +0000
+++ new/usr/src/uts/common/dtrace/sdt_subr.c	2012-08-18 10:37:07.698630889 +0000
@@ -107,6 +107,7 @@
 	{ "ip", "__ip_", &stab_attr, 0 },
 	{ "tcp", "__tcp_", &stab_attr, 0 },
 	{ "udp", "__udp_", &stab_attr, 0 },
+	{ "dccp", "__dccp_", &stab_attr, 0 },
 	{ "mib", "__mib_", &stab_attr, 0 },
 	{ "fsinfo", "__fsinfo_", &fsinfo_attr, 0 },
 	{ "iscsi", "__iscsi_", &iscsi_attr, 0 },
@@ -943,6 +944,49 @@
 	{ "udp", "receive", 3, 3, "udp_t *", "udpsinfo_t *" },
 	{ "udp", "receive", 4, 4, "udpha_t *", "udpinfo_t *" },
 
+	{ "dccp", "connect-established", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "connect-established", 1, 1, "ip_xmit_attr_t *",
+	    "csinfo_t *" },
+	{ "dccp", "connect-established", 2, 2, "void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "connect-established", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "connect-established", 4, 4, "dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "connect-refused", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "connect-refused", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "connect-refused", 2, 2, "void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "connect-refused", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "connect-refused", 4, 4, "dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "connect-request", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "connect-request", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "connect-request", 2, 2, "void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "connect-request", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "connect-request", 4, 4, "dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "accept-established", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "accept-established", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "accept-established", 2, 2, "void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "accept-established", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "accept-established", 4, 4, "dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "accept-refused", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "accept-refused", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "accept-refused", 2, 2, "void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "accept-refused", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "accept-refused", 4, 4, "dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "state-change", 0, 0, "void", "void" },
+	{ "dccp", "state-change", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "state-change", 2, 2, "void", "void" },
+	{ "dccp", "state-change", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "state-change", 4, 4, "void", "void" },
+	{ "dccp", "state-change", 5, 5, "int32_t", "dccplsinfo_t *" },
+	{ "dccp", "send", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "send", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "send", 2, 2, "__dtrace_dccp_void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "send", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "send", 4, 4, "__dtrace_dccp_dccph_t *", "dccpinfo_t *" },
+	{ "dccp", "receive", 0, 0, "mblk_t *", "pktinfo_t *" },
+	{ "dccp", "receive", 1, 1, "ip_xmit_attr_t *", "csinfo_t *" },
+	{ "dccp", "receive", 2, 2, "__dtrace_dccp_void_ip_t *", "ipinfo_t *" },
+	{ "dccp", "receive", 3, 3, "dccp_t *", "dccpsinfo_t *" },
+	{ "dccp", "receive", 4, 4, "__dtrace_dccp_dccph_t *", "dccpinfo_t *" },
+
 	{ "sysevent", "post", 0, 0, "evch_bind_t *", "syseventchaninfo_t *" },
 	{ "sysevent", "post", 1, 1, "sysevent_impl_t *", "syseventinfo_t *" },
 
--- old/usr/src/uts/common/inet/Makefile	2012-08-18 10:37:08.069076164 +0000
+++ new/usr/src/uts/common/inet/Makefile	2012-08-18 10:37:08.102859760 +0000
@@ -34,7 +34,8 @@
 	led.h mi.h mib2.h nd.h optcom.h sadb.h sctp_itf.h snmpcom.h tcp.h \
 	tcp_sack.h tcp_stack.h tunables.h udp_impl.h rawip_impl.h ipp_common.h \
 	ip_ftable.h ip_impl.h ip_stack.h ip_arp.h tcp_impl.h wifi_ioctl.h \
-	ip2mac.h ip2mac_impl.h tcp_stats.h
+	ip2mac.h ip2mac_impl.h tcp_stats.h dccp.h dccp_impl.h dccp_ip.h \
+	dccp_stack.h dccp_stats.h
 
 ROOTDIRS= $(ROOT)/usr/include/inet
 
--- /dev/null	2012-08-18 10:37:08.000000000 +0000
+++ new/usr/src/uts/common/inet/dccp.h	2012-08-18 10:37:08.481916091 +0000
@@ -0,0 +1,247 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner. All rights reserved.
+ */
+
+#ifndef	_INET_DCCP_H
+#define	_INET_DCCP_H
+
+#include <sys/inttypes.h>
+#include <sys/socket.h>
+#include <sys/socket_proto.h>
+
+#include <netinet/in.h>
+#include <netinet/ip6.h>
+#include <netinet/dccp.h>
+
+#include <inet/common.h>
+#include <inet/ip.h>
+#include <inet/ip6.h>
+#include <inet/tunables.h>
+#include <inet/dccp_stack.h>
+#include <inet/optcom.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/*
+ * DCCP states
+ */
+#define	DCCPS_CLOSED		1
+#define	DCCPS_BOUND		2
+#define	DCCPS_REQUEST		3
+#define	DCCPS_LISTEN		4
+#define	DCCPS_PARTOPEN		5
+#define	DCCPS_RESPOND		6
+#define	DCCPS_OPEN		7
+#define	DCCPS_CLOSING		8
+#define	DCCPS_CLOSEREQ		9
+#define	DCCPS_TIMEWAIT		10
+
+/*
+ * DCCP header structures.
+ */
+
+/* Generic protocol header (RFC 4340, Section 5.1.) */
+typedef struct dccphdr_s {
+	uint8_t		dh_lport[2];
+	uint8_t		dh_fport[2];
+	uint8_t		dh_offset;
+	uint8_t		dh_ccval:4,
+			dh_cscov:4;
+	uint8_t		db_sum[2];
+	uint8_t		dh_reserved:3,
+			dh_type:4,
+			dh_x:1;
+	uint8_t		dh_res_seq;
+	uint8_t		dh_seq[2];
+} dccph_t;
+
+#define	DCCP_HDR_LENGTH(dccph)	\
+	(((dccph_t *)dccph)->dh_offset * 4) /* XXX >> 2 */
+#define	DCCP_MAX_HDR_LENGTH		1020
+#define	DCCP_MIN_HEADER_LENGTH		12
+
+/* Generic protocol header aligned (RFC 4340, Section 5.1.) */
+typedef struct dccphdra_s {
+	in_port_t	dha_lport;		/* Source port */
+	in_port_t	dha_fport;		/* Destination port */
+	uint8_t		dha_offset;		/* Data offset */
+	uint8_t		dha_cscov:4,		/* Checksum coverage */
+			dha_ccval:4;		/* */
+	uint16_t	dha_sum;		/* Checksum */
+	uint8_t		dha_x:1,		/* Reserved */
+			dha_type:4,		/* Packet type */
+			dha_reserved:3;		/* Header type */
+	uint8_t		dha_res_seq;
+	uint16_t	dha_seq;		/* Partial sequence number */
+} dccpha_t;
+
+typedef struct dccphdra_ext_s {
+	uint32_t	dha_ext_seq;
+} dccpha_ext_t;
+
+/* Acknowledgement number */
+typedef struct dccphdra_ack {
+	uint16_t	dha_ack_reserved;
+	uint16_t	dha_ack_high;
+	uint32_t	dha_ack_low;
+} dccpha_ack_t;
+
+/* Service number */
+typedef	struct dccphdra_srv {
+	uint32_t	dha_srv_code;
+} dccpha_srv_t;
+
+/* Reset data */
+typedef struct dccphdra_reset {
+	uint8_t		dha_reset_code;
+	uint8_t		dha_reset_data[3];
+} dccpha_reset_t;
+
+/*
+ * Control structure for each open TCP stream,
+ * defined only within the kernel or for a kmem user.
+ * NOTE: tcp_reinit_values MUST have a line for each field in this structure!
+ */
+#if (defined(_KERNEL) || defined(_KMEMUSER))
+
+/* Internal DCCP structure */
+typedef struct dccp_s {
+
+	conn_t		*dccp_connp;	/* Backpointer to conn_t */
+	dccp_stack_t	*dccp_dccps;	/* Backpointer to dccp_stack_t */
+
+	int32_t		dccp_state;
+
+	uint64_t	dccp_last_rcv_lbolt;
+
+	uint32_t	dccp_ibsegs;	/* Inbound segments on this stream */
+	uint32_t	dccp_obsegs;	/* Outbound segments on this stream */
+
+	uint32_t
+		dccp_hard_binding: 1,
+		dccp_loopback: 1,	/* Src and dst are the same machine */
+		dccp_localnet: 1,	/* Src and dst are on the same subnet */
+		dccp_active_open: 1,	/* This is a active open */
+		dccp_detached : 1,	/* If we're detached from a stream */
+		dccp_dummy: 1;
+
+	uint32_t
+		dccp_tconnind_started: 1,
+		dccp_dummy2: 1;
+
+	uint32_t
+		dccp_allow_short_seqnos: 1,
+		dccp_ecn_incapable: 1;
+
+	/*
+	 * Timers and timestamps.
+	 */
+	mblk_t		*dccp_timercache;	/* Timer cache */
+
+	timeout_id_t	dccp_timer_tid;		/* Timer service id */
+	timeout_id_t	dccp_ka_tid;		/* Keepalive timer id */
+
+	clock_t		dccp_timestamp_init;	/* Time reference */
+	int32_t		dccp_timestamp_echo;	/* Timestamp found in options */
+	clock_t		dccp_timestamp;
+
+	clock_t		dccp_first_timer_threshold;
+	clock_t		dccp_second_timer_threshold;
+	clock_t		dccp_first_ctimer_threshold;
+	clock_t		dccp_second_ctimer_threshold;
+
+	int32_t		dccp_ka_last_intrvl;	/* Last probe interval */
+	uint32_t	dccp_ka_interval;	/* Keepalive interval */
+	uint32_t	dccp_ka_rinterval;	/* Keepalive retransmit */
+	uint32_t	dccp_ka_abort_thres;	/* Abort threshold */
+	uint32_t	dccp_ka_cnt;		/* Probes counter */
+
+	int64_t		dccp_last_recv_time;	/* Last segment recv time */
+
+	int		dccp_conn_req_max;	/* # request allowed */
+
+	int32_t		dccp_client_errno;	/* How the client screwed up */
+
+	/*
+	 * Bind related.
+	 */
+	struct dccp_s	*dccp_bind_hash;	/* Bind hash chain */
+	struct dccp_s	*dccp_bind_hash_port;	/* Bound to the same port */
+	struct dccp_s	**dccp_ptpbhn;
+
+	struct dccphdra_s *dccp_dccpha;		/* Template header */
+
+	mblk_t		*dccp_xmit_head;
+
+	/*
+	 * Pointers into the header template.
+	 */
+	ipha_t		*dccp_ipha;
+	ip6_t		*dccp_ip6h;
+
+	t_uscalar_t	dccp_acceptor_id;	/* ACCEPTOR_id */
+
+	sock_connid_t	dccp_connid;
+
+	/* Incrementing pending conn req ID */
+	t_scalar_t	dccp_conn_req_seqnum;
+
+	boolean_t	dccp_issocket;		/* This is a socket dccp */
+
+	/* List of features being negotiated */
+	list_t		dccp_features;
+
+	struct dccp_s	*dccp_listener;		/* Our listener */
+	struct dccp_s	*dccp_saved_listener;	/* Saved listener */
+
+	kmutex_t	dccp_eager_lock;
+
+	/*
+	 * Sequence numbers (Section 7.1.)
+	 */
+	uint64_t	dccp_swl;	/* Sequence number window low */
+	uint64_t	dccp_swh;	/* Sequence number window high */
+	uint64_t	dccp_awl;	/* Ack number window low */
+	uint64_t	dccp_awh;	/* Ack number window high */
+	uint64_t	dccp_iss;	/* Initial sequence number sent */
+	uint64_t	dccp_isr;	/* Initial sequence number received */
+	uint64_t	dccp_osr;	/* First OPEN sequence number */
+	uint64_t	dccp_gss;	/* Greatest sequence number sent */
+	uint64_t	dccp_gsr;	/* Greatest sequence */
+					/* number received */
+	uint64_t	dccp_gar;	/* Greatest acknowledgement */
+					/* number received */
+
+	uint64_t	dccp_sequence_window;
+
+	uint8_t		dccp_reset_code;
+	uint8_t		dccp_reset_data[3];
+} dccp_t;
+
+typedef struct dccp_df_s {
+	struct dccp_s	*df_dccp;
+	kmutex_t	df_lock;
+	uchar_t		df_pad[TF_CACHEL_PAD - (sizeof (dccp_t *) +
+			    sizeof (kmutex_t))];
+} dccp_df_t;
+
+#endif	/* _KERNEL */
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _INET_DCCP_H */
